#ifndef ADCSTATUS_H
#define ADCSTATUS_H

#include <optional>
#include <QMap>
#include <QMetaType>

#include "ModularDeviceStatus.h"
#include "base/ConfigKey.h"
#include "device-modules/OneWire/BMStatus.h"

class AdcStatus: public ModularDeviceStatus
{
public:
    explicit AdcStatus(const DeviceIndex &deviceIndex = {})
        : ModularDeviceStatus(deviceIndex) {}

    friend bool operator==(const AdcStatus &, const AdcStatus &) = default;

    QMap<QString, double> getBMTemps() const;

    std::optional<BMStatus> bmStatus;
    std::optional<ConfigKey> setup_key; // key of last configuration loaded to device
};
Q_DECLARE_METATYPE(AdcStatus)

#endif // ADCSTATUS_H
