#ifndef BMNTRCDEVICEGLOBAL_H
#define BMNTRCDEVICEGLOBAL_H

#include "mstream-mreg-dev-global/MstreamMregDevGlobal.h"
#include "BmnTrcStatus.h"

class TrcDevice;
class TrcDeviceConfig;
struct BaseDeviceAppConfig;

class TrcDeviceGlobal : public MstreamMregDevGlobal
{
    Q_OBJECT
public:
    explicit TrcDeviceGlobal(const DeviceIndex &index, QObject *parent = nullptr);
    BmnTrcStatus getTrcDevStatus() const { return trcDevStatus; }

signals:
    void sendJsonBlock(const DeviceIndex &, const QByteArray &data) const;

public slots:
    void deviceStatusUpdated(const BmnTrcStatus &status);

protected:
    virtual void postAddMStreamDump(MStreamDump *) override;

private:
    void onSpillStateUpdated(const BmnTrcStatus &devSt);

private:
    BmnTrcStatus trcDevStatus;
    bool pendingStatusSend = false;
    bool lookForStop = false;
    quint32 stopEvNum = 0;
};

#endif // BMNTRCDEVICEGLOBAL_H
