#include "TrcConfigDispatcher.h"
#include "lib-common/BaseDeviceAppConfig.h"

TrcConfigDispatcher::TrcConfigDispatcher(QObject *parent)
    : ReadoutAppConfigDispatcher(parent)
{}

void TrcConfigDispatcher::deviceInfoUpdated(const DeviceIndex &index, quint16 auxNch, quint16 phyNch)
{
    Q_UNUSED(index)
    Q_UNUSED(auxNch)
    Q_UNUSED(phyNch)
    // for future use
//    auto cfgIt = cache->knownConfigs.find(index);
//    if(cfgIt == cache->knownConfigs.end())
//        return;
//    auto &cfg = cfgIt.value();
//    if(cfg.phyTrig.chCfg.size() != auxNch) {
//        //        cfg.phyTrig.chCfg.resize(chNum);
//        //        emit configChanged(config);
//    }
//    if(cfg.phyTrig.chCfg.size() != phyNch) {
//        //        cfg.phyTrig.chCfg.resize(chNum);
//        //        emit configChanged(config);
//    }
}

void TrcConfigDispatcher::setSpillCfg(const SpillConfig &cfg)
{
    cache->defaultSetup.trcCore.phyTrig.spill = cfg;
    cache->unify_config();
    incrementConfigKey();
}

void TrcConfigDispatcher::setRcTrigCfg(const RcTrigConfig &cfg)
{
    cache->defaultSetup.trcCore.phyTrig.trig = cfg;
    cache->defaultSetup.trcCore.unifyAuxTrig();
    cache->unify_config();
    incrementConfigKey();
}

void TrcConfigDispatcher::setPhyTrigCfg(const PhysicalTriggerConfig &cfg)
{
    cache->defaultSetup.trcCore.phyTrig = cfg;
    cache->defaultSetup.trcCore.unifyAuxTrig();
    cache->unify_config();
    incrementConfigKey();
}

void TrcConfigDispatcher::sendConfigKeyCache()
{
    BaseConfigDispatcher::sendConfigKeyCache();

    emit spillCfgChanged(cache->defaultSetup.trcCore.phyTrig.spill);
    emit rcTrigCfgChanged(cache->defaultSetup.trcCore.phyTrig.trig);
    emit phyTrigCfgChanged(cache->defaultSetup.trcCore.phyTrig);
}
