#include "CruMainWindow.h"
#include "CruApp.h"
#include "CruCore.h"

#include "base/app/RunGuard.h"
#include "base/Globals.h"
#include "mongo/PrintConfigMap.h"

int main(int argc, char *argv[])
{
    Globals::setDaqModuleType(DaqModule::Type::Cru);
    CruApp daqApp(argc, argv);
    daqApp.init();

    if(daqApp.hasConfigListOpt())
        printConfigMap();

    RunGuard::runSingleOrExit();

    if(daqApp.isGuiApp()) {
        CruMainWindow *mw(new CruMainWindow);
        mw->show();
    }
    CruCore core;

    return daqApp.exec();
}
