#ifndef REGOPTABLEVIEW_H
#define REGOPTABLEVIEW_H

#include <QTableView>

class HexSpinBoxDelegate;
class RegTypeComboBoxDelegate;
class SdbComboBoxDelegate;

class RegOpTableView : public QTableView
{
    Q_OBJECT
public:
    RegOpTableView(QWidget *parent = nullptr);
    void setModel(QAbstractItemModel *model) override;
    void setSdbMap(const QMap<QString, QPair<quint32, quint32>> &sdbMap);

private slots:
    void addDelegate();

private:
    HexSpinBoxDelegate * hexSbDelegate;
    RegTypeComboBoxDelegate * regTypeDelegate;
    SdbComboBoxDelegate * const sdbDelegate;
    QMap<QString, QPair<quint32, quint32>> sdbMap;
};

#endif // REGOPTABLEVIEW_H
