//
//    Copyright 2013 Ilja Slepnev
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.
//

#ifndef HRBREGS_H
#define HRBREGS_H

enum {
    REG_CONTROL = 0x40,
    REG_RSTATUS = 0x41,
    REG_SETUP = 0x42,
    REG_TEST = 0x43,
    REG_TRIG_MATCH = 0x44,
    REG_TRIG_LATENCY = 0x45,
    REG_TTC_STATE = 0x46,
    REG_TRIG_SRC = 0x47,
    REG_TIMER_TRIG_PERIOD = 0x48,
    REG_SPILL_CTRL = 0x49,
    REG_TEMPERATURE = 0x54, //
    REG64_SERIAL_ID = 0x50, // 80
    REG_FW_VER = 0x56, // 86
    REG_FW_REV = 0x57, // 87
    REG_INSTATE_0 = 0x58,
    REG_INSTATE_1 = 0x59,
    REG_INSTATE_2 = 0x5A,
    REG_INSTATE_3 = 0x5B,
    REG_INSTATE_4 = 0x5C,
    REG_INSTATE_5 = 0x5D,
    REG_INSTATE_6 = 0x5E,
    REG_INSTATE_7 = 0x5F,

    REG_DIRECT_HIT_COUNTERS_BASE   = 0x100,
    REG_WIN_HIT_COUNTERS_BASE   = 0x400,

    REG_CORE0 = 0x200,
    REG32_MIN_HIT_DURATION = 0x201,
    REG32_TRIG_PASS  = 0x202,
    REG32_TRIG_BLOCK = 0x204,
    REG32_EVENT_NR = 0x206,
    REG32_SPILL_NR = 0x208,
    REG32_BUSY_TIMEOUT_CNT = REG_CORE0 + 0xA,
    REG64_SYSTEM_TS = 0x20C,
    REG64_BUSY_TIMER = REG_CORE0 + 0x10,
    REG64_IDLE_TIMER = REG_CORE0 + 0x14,
    REG64_GLOB_EVENT_NR = 0x218,
    REG16_FIFO_SIZE = 0x21C,
    REG64_BUSY_MSTR_TIMER = REG_CORE0 + 0x20,
    REG64_IDLE_MSTR_TIMER = REG_CORE0 + 0x24,

//    REG_TTC_CONTROL = 0x300,
//    REG_TTC_CLK_ERR = 0x302,
//    REG_TTC_TS_ZERO_MISMATCH = 0x303,
//    REG_TTC_LINK1_SYNC_LOSS = 0x304,
//    REG_TTC_LINK2_SYNC_LOSS = 0x305,
//    REG_TTC_LINK1_CODE_OR_DISP_ERR = 0x306,
//    REG_TTC_LINK2_CODE_OR_DISP_ERR = 0x307,

    REG32_TTC_STATISTICS_BASE = 0x300,
    REG32_TTC_STATISTICS_NUM  = 5, // number of 32-bit counters
    REG32_TTC_TS_ZERO_MISMATCH = REG32_TTC_STATISTICS_BASE,
    REG32_TTC_TRIG_SYNC_LOSS   = REG32_TTC_STATISTICS_BASE + 2,
    REG32_TTC_TRIG_CODE_ERR    = REG32_TTC_STATISTICS_BASE + 4,
    REG32_TTC_RESET_SYNC_LOSS  = REG32_TTC_STATISTICS_BASE + 6,
    REG32_TTC_RESET_CODE_ERR   = REG32_TTC_STATISTICS_BASE + 8,

    REG_THR_DAC = 0x310,

    REG_PULSER_BASE = 0x320,
    REG_PULSER_RAND_EN = REG_PULSER_BASE,
    REG_PULSER_PER_EN  = REG_PULSER_BASE + 1,
    REG_PULSER_EXT_EN  = REG_PULSER_BASE + 2,
    REG_PULSER_PER_0   = REG_PULSER_BASE + 4,
    REG_PULSER_PER_1   = REG_PULSER_PER_0 + 2,
    REG_PULSER_PER_2   = REG_PULSER_PER_1 + 2,
    REG_PULSER_PER_3   = REG_PULSER_PER_2 + 2,
    REG_PULSER_PER_4   = REG_PULSER_PER_3 + 2,
    REG_PULSER_PER_5   = REG_PULSER_PER_4 + 2
};

enum {
    TRIG_SRC_BIT_TTL_SPILL_EN   = 0x0001,
    TRIG_SRC_BIT_TTL_TRIG_EN    = 0x0002,
    TRIG_SRC_BIT_LVDS_SPILL_EN  = 0x0004,
    TRIG_SRC_BIT_LVDS_TRIG_EN   = 0x0008,
    TRIG_SRC_BIT_TIMER_SPILL_EN = 0x0010,
    TRIG_SRC_BIT_TIMER_TRIG_EN  = 0x0020
};

#endif // HRBREGS_H
