#include "EvbGenConfigDb.h"

#include "EvbGenConfigConverter.h"

EvbGenConfigDb::EvbGenConfigDb(QObject *parent)
    : AbstractConfigDb(parent)
{
    AbstractConfigConverter<GenServerConfig>::registerTypes();
    AbstractConfigConverter<EvbGenConfig>::registerTypes();
}

void EvbGenConfigDb::setEvbGenConfig(const EvbGenConfig &newConfig)
{
    if(!initialized)
        return;
    if (newConfig == config)
        return;
    config = newConfig;

    auto json = QVariant::fromValue(config).value<QJsonObject>();
    write_config(json);
}

void EvbGenConfigDb::update_config_from_db()
{
    auto conf_json = BaseConfig::readConfig(cs);
    config = QVariant::fromValue(conf_json).value<EvbGenConfig>();
    if(config.cfgBase.useMax && config.cfgBase.eventLengthMax < config.cfgBase.event_length) {
        qWarning() << __PRETTY_FUNCTION__
                   << QString("eventLengthMax(%L1) < event_length(%L2): set all to minimal")
                          .arg(config.cfgBase.eventLengthMax)
                          .arg(config.cfgBase.event_length);
        config.cfgBase.event_length = config.cfgBase.eventLengthMax;
    }
    emit evbGenConfigChanged(config);
}
