#ifndef GENSERVERFSM_H
#define GENSERVERFSM_H

#include "fsm/BaseFsm.h"

struct GenServerFsmInput : public BaseFsmInput
{
    bool connected = false;
    bool allDone = false;
};

class GenServerFsm : public BaseFsm
{
    Q_OBJECT
public:
    explicit GenServerFsm(int _id, QObject *parent = nullptr);
    virtual bool isTransitionAllowed(const FsmState &toState) const;

public slots:
    void setConnected(bool connected);
    void setAllDone(bool done);

protected slots:
    virtual bool evaluate() override;

protected:
    virtual void printInputString(QDebug dbg) const override;
    inline GenServerFsmInput *getInput() {
        return static_cast<GenServerFsmInput*>(BaseFsm::getInput());
    }
    inline const GenServerFsmInput *getInput() const {
        return static_cast<const GenServerFsmInput*>(BaseFsm::getInput());
    }
private:
    const int id;
};

QDebug operator<<(QDebug dbg, const GenServerFsmInput &in);


#endif // GENSERVERFSM_H
