#ifndef EVBGENCONFIGFORM_H
#define EVBGENCONFIGFORM_H

#include <QWidget>

#include "EvbGenConfig.h"

namespace Ui {
class EvbGenConfigForm;
}

class EvbGenConfigForm : public QWidget
{
    Q_OBJECT

public:
    explicit EvbGenConfigForm(QWidget *parent = nullptr);
    ~EvbGenConfigForm();

public slots:
    void setEvbGenConfig(const EvbGenConfig &newConfig);

signals:
    void evbGenConfigChanged(const EvbGenConfig &config) const;

private slots:
    void on_spinBoxClients_valueChanged(int val);
    void on_spinBoxPreRunWait_valueChanged(int val);
    void on_spinBoxSpillCount_valueChanged(int val);
    void on_spinBoxSpillTime_valueChanged(int val);
    void on_spinBoxInterspillTime_valueChanged(int val);
    void on_doubleSpinBoxEvRate_valueChanged(double val);
    void on_spinBoxEvPayload_valueChanged(int val);
    void on_checkBoxPayloadMax_toggled(bool useMax);
    void on_spinBoxEvPayloadMax_valueChanged(int val);


private:
    void updateGuiToConfig();
    void updateLabels();
    void updatePayloadLimits() const;
    Ui::EvbGenConfigForm *ui;

    EvbGenConfig config;
};

#endif // EVBGENCONFIGFORM_H
