#include "EvbGenApp.h"

#include "base/app/RunGuard.h"
#include "base/Globals.h"

#include "GenStartupOptions.h"
#include "EvbGenCore.h"
#include "EvbGenMainWindow.h"

#include "QDebug"
#include "exception"
#include "iostream"

int main(int argc, char *argv[])
{
    Globals::setDaqModuleType(DaqModule::Type::Generator);

    try {
        EvbGenApp app(argc, argv);
        app.init();

        RunGuard::runSingleOrExit();


        if(app.isGuiApp()) {
            EvbGenMainWindow *mw(new EvbGenMainWindow);
            mw->show();
        }

        EvbGenCore gen(app.getStartupOptions());
        return app.exec();
    }
    catch (std::exception &exc) {
        std::cerr << exc.what() << std::endl;
        return -1;
    }

    return 0;
}

