#ifndef EVBDEBUGLABEL_H
#define EVBDEBUGLABEL_H

#include <QLabel>
#include <optional>

#include "CombinerStats.h"

struct TcpClientStatus;

class EvbDebugLabel : public QLabel
{
    Q_OBJECT
public:
    EvbDebugLabel(QWidget *parent=nullptr, Qt::WindowFlags f=Qt::WindowFlags());
    void updateDebugInfoLabel(const QHash<ClientIndex, TcpClientStatus> &lastTcpClientStatus,
                              const CombinerStats &cs);

    void setStatus();

protected:
    virtual void mouseDoubleClickEvent(QMouseEvent *event);

private:
    std::optional<CombinerStats> repeCombStats;
    CombinerStats lastCombinerStats;
    QPair<ClientIndex, std::optional<double>> minClient, maxClient;
};

#endif // EVBDEBUGLABEL_H
