#ifndef MPDTLUSIGNALROUTER_H
#define MPDTLUSIGNALROUTER_H

#include "lib-common/ReadoutAppSignalRouter.h"

class ReadoutAppConfigDb;
class ReadoutAppConfigDispatcher;
class MpdTluCore;
class MpdTluDeviceGlobal;
class MpdTluMainWindow;
class Tlu16SfpModel;
class Tlu40LvdsModel;
class TluTtlIoWidget;

class MpdTluSignalRouter : public ReadoutAppSignalRouter
{
    MpdTluSignalRouter();
    Q_DISABLE_COPY_MOVE(MpdTluSignalRouter)
public:
    // Singleton
    static MpdTluSignalRouter & instance()
    {
        // thread-safe since C++11
        static MpdTluSignalRouter obj;
        return obj;
    }

    void setCore(MpdTluCore *p);
    void setConfigDb(ReadoutAppConfigDb * p)
    { configDb = p; }
    void setMainWindow(MpdTluMainWindow *p);
    void setReadoutAppConfigDispatcher(ReadoutAppConfigDispatcher *p);

    // void connectAll() const override;
    void connect_TluDeviceGlobal(const MpdTluDeviceGlobal *devGlob);

protected:
    virtual void connect_ConfigurationDispatcher() const override;
    virtual void connect_FSM() const override;
    virtual void connect_MainWindow() const override;

    ReadoutAppConfigDb * configDb = nullptr;
    ReadoutAppConfigDispatcher *readoutConfDisp = nullptr;
    MpdTluCore *core = nullptr;
    MpdTluMainWindow  *tluMw = nullptr;
    Tlu16SfpModel *tlu16SfpModel = nullptr;
    Tlu40LvdsModel *tlu40LvdsModel = nullptr;
    TluTtlIoWidget *tluTtlIoWidget16Sfp = nullptr;
    TluTtlIoWidget *tluTtlIoWidget40Lvds = nullptr;
};

#endif // MPDTLUSIGNALROUTER_H
