#ifndef TLU40LVDSWIDGET_H
#define TLU40LVDSWIDGET_H

#include <QWidget>

#include "fsm/FsmState.h"
#include "lib-common/BaseDeviceAppConfig.h"

class Tlu40LvdsModel;
class ConfigKey;
class CommonSpinBoxDelegate;

namespace Ui {
class Tlu40LvdsWidget;
}

class Tlu40LvdsWidget : public QWidget
{
    Q_OBJECT

public:
    explicit Tlu40LvdsWidget(QWidget *parent = nullptr);
    ~Tlu40LvdsWidget();
    Tlu40LvdsModel *getModel() const { return model; }

public slots:
    void updateRemoteBlocking(bool remoteConnected) const;
    void setConfig(const ConfigKey &config_key, const BaseDeviceAppConfig &newConfig);
    void onFsmStateChange(const FsmState &state);

private slots:
    void onModelReset();

signals:
    void configChanged(const BaseDeviceAppConfig &config) const;

private:
    void addDelegate(const QModelIndex &index);

    Ui::Tlu40LvdsWidget *ui;
    BaseDeviceAppConfig appConfig;
    Tlu40LvdsModel * const model;
    CommonSpinBoxDelegate * const shaperSbDelegate;
};

#endif // TLU40LVDSWIDGET_H
