#ifndef MSCCONFIGDISPATCHER_H
#define MSCCONFIGDISPATCHER_H

#include "lib-common/ReadoutAppConfigDispatcher.h"

class BaseDeviceAppConfig;
struct MscBuildParams;

class MscConfigDispatcher : public ReadoutAppConfigDispatcher
{
    Q_OBJECT
    explicit MscConfigDispatcher(QObject *parent = nullptr);
    Q_DISABLE_COPY_MOVE(MscConfigDispatcher);
public:
    // Singleton
    static MscConfigDispatcher & instance()
    {
        // thread-safe since C++11
        static MscConfigDispatcher obj;
        return obj;
    }

public slots:
    void setConfig(const BaseDeviceAppConfig &config) override;
    void setDeviceConfig(const DeviceIndex &index,
                         const ModularDeviceConfig &config) override;
    void setBuildParameters(const DeviceIndex &index,
                            const MscBuildParams &b_params);
    void resetConfigHistCh();

private:
    void check_config();
    void sendConfigKeyCache() override;

};

#endif // MSCCONFIGDISPATCHER_H
