#ifndef PNPBEACON_H
#define PNPBEACON_H

#include "pnp-server/PNPMessage.h"

#include <QObject>
#include <QStringList>

class QTimer;

class PNPBeacon : public QObject
{
    Q_OBJECT
public:
    explicit PNPBeacon(QStringList args = QStringList());
    virtual ~PNPBeacon() override;

signals:
    void updateProgramDescription(const ProgramDescription &pd) const;
    void closeProgram(const ProgramDescription &) const;

private slots:
    void sendMessage();
private:
    QTimer * const sendTimer;
    ProgramDescription progDescr;
    uint sendCnt = 0;
};

#endif // PNPBEACON_H
