//
//    Copyright 2015 Ilja Slepnev
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.
//

#include "WrEpState.h"

#include <QDebug>
#include <QDateTime>

QString WrStatusBits::toString() const
{
    return QString("%1 %2 %3")
                .arg(code.bit.sfp?"SFP_Ok":"SFP_ERROR")
                .arg(code.bit.link?"Link_Up":"Link_Down")
                .arg(code.bit.sync?"SYNC":"SYNC_LOST")
                ;
}

QDebug &operator<<(QDebug stream, const WrStatusBits &status)
{
    return stream << status.toString();
}

QString WrTaiCode::toString() const
{
    return QString("%1.%2")
            .arg(QDateTime::fromTime_t(code.bit.tai_sec).toString("t dd.MM.yyyy hh:mm:ss"))
            .arg(code.bit.tai_nsec, 9, 10, QChar('0'))
            ;
}

QDebug &operator<<(QDebug stream, const WrTaiCode &tai)
{
    return stream << tai.toString();
}
