#ifndef SNMPCTRL_H
#define SNMPCTRL_H

#include <QString>
#include <QVector>
#include <QPair>
#include <QVariant>
#include <QString>
#include <string>

class snmp_session;

class SnmpCtrl
{
public:
    SnmpCtrl();
    SnmpCtrl(char *);
    int add_mib_dir(QString dir);
    void check_mib();
    void setHost(QString s);
    void setCommunity(QString s);
    bool get_str(const char *oid_str, QString *str);
    bool get_int(const char *oid_str, long *val);
    bool debug_print(const char *oid_str);
    bool print_test2(QStringList id_list, QVector<QPair<QString, QVariant> > *responce_vars);
    bool print_test_dec();
    bool set_vars(QMap<QString, QVariant> vars);

    bool connect();
    void disconnect();
private:
    bool isConnected() const { return ss!=nullptr; }

    QString host;
    QString community;
    std::string host_str;
    std::string community_str;
    char host_buff[100];
    char community_buff[100];
    snmp_session *session;
    snmp_session *ss;
};

#endif // SNMPCTRL_H
