#ifndef TTVXSREGS_H
#define TTVXSREGS_H

#include "mregdev/MregDeviceAdcm.h"

enum {
    // Control registers
    REG_DEVICE_CTRL = mlink::MregDeviceAdcm::ADCM16_CTRL_REG,
};
enum {
    // Run Control Core Registers
    REG_RC_BASE = 0x200,
    REG_RC_CTRL                     = REG_RC_BASE + 0x00,
    REG_RC_TRIG_SRC                 = REG_RC_BASE + 0x02,
    REG_RC_TRIG_STATE               = REG_RC_BASE + 0x03,
    REG32_RC_BUSY_MASK              = REG_RC_BASE + 0x04,
    REG32_BUSY_INPUT_STATE          = REG_RC_BASE + 0x06, // RO
    REG32_BUSY_TIMEOUT_STATE        = REG_RC_BASE + 0x08, // RO
    REG32_FIXED_FREQ_PULSER_PERIOD  = REG_RC_BASE + 0x0A, // R/W
    REG32_RANDOM_PULSER_PROBABILITY = REG_RC_BASE + 0x0C, // R/W
    REG32_RANDOM_PULSER_DEAD_TIME   = REG_RC_BASE + 0x0E, // R/W
    REG_TRIG_QUEUE                  = REG_RC_BASE + 0x10, // RO
    REG_BUSY_SOURCE                 = REG_RC_BASE + 0x12, // R/W
    REG64_EVENT_NUMBER_LOAD         = REG_RC_BASE + 0x14, // R/W
    REG64_CUR_EVENT_NUMBER          = REG_RC_BASE + 0x18, // RO
    REG128_BUILD_PARAMS             = REG_RC_BASE + 0x20, //RO
};

enum {
    // Error Counters
    REG_ERROR_BASE = 0x1000,
    REG64_HWIP_Link_Down = REG_ERROR_BASE + 0x00,
    REG64_REG_IO_ERROR   = REG_ERROR_BASE + 0x04,
    REG64_SFP_ERROR_ETH  = REG_ERROR_BASE + 0x08,
    REG64_HWIP_ERROR     = REG_ERROR_BASE + 0x0C,
    REG64_TX_ERROR_ETH   = REG_ERROR_BASE + 0x10,
    REG64_RX_ERROR_ETH   = REG_ERROR_BASE + 0x14
};

enum {
    // Error Counters
    REG_AUX_CNT_BASE = 0x1200,
//    REG64_HWIP_Link_Down = REG_ERROR_BASE + 0x00,
//    REG64_REG_IO_ERROR   = REG_ERROR_BASE + 0x04,
//    REG64_SFP_ERROR_ETH  = REG_ERROR_BASE + 0x08,
//    REG64_HWIP_ERROR     = REG_ERROR_BASE + 0x0C,
//    REG64_TX_ERROR_ETH   = REG_ERROR_BASE + 0x10,
//    REG64_RX_ERROR_ETH   = REG_ERROR_BASE + 0x14
};

#endif // TTVXSREGS_H

