/*
**    Copyright 2020 Ilia Slepnev
**
**    This program is free software: you can redistribute it and/or modify
**    it under the terms of the GNU General Public License as published by
**    the Free Software Foundation, either version 3 of the License, or
**    (at your option) any later version.
**
**    This program is distributed in the hope that it will be useful,
**    but WITHOUT ANY WARRANTY; without even the implied warranty of
**    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**    GNU General Public License for more details.
**
**    You should have received a copy of the GNU General Public License
**    along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/

#ifndef TTVXSSTATUS_H
#define TTVXSSTATUS_H

#include <QMetaType>

#include "ModularDeviceStatus.h"
#include "TtvxsAuxCounters.h"

struct TtvxsDeviceCoreStatus
{
    quint16 trigState = 0;
    quint32 timeoutState = 0;
    quint16 trigQueue = 0;
    quint32 inputState = 0;

    TtvxsAuxCounters aux_cnt;
};

class TtvxsStatus: public ModularDeviceStatus
{
public:
    explicit TtvxsStatus(const DeviceIndex &deviceIndex = {})
        : ModularDeviceStatus(deviceIndex) {}

    std::array<quint32, 4> buildParams = {};
    TtvxsDeviceCoreStatus coreStatus;
};
Q_DECLARE_METATYPE(TtvxsStatus)

#endif // TTVXSSTATUS_H
