#ifndef TDCVIEWERCONFIG_H
#define TDCVIEWERCONFIG_H

#include <QMetaType>

#include "base/ClientIndex.h"
#include "file-reader-dialog/FileReaderConfig.h"
#include "histogramm/HistMngrCfg.h"
#include "histogramm/DeviceCalibration.h"
#include "pnp-server/PNPMessage.h"
#include "zmq-lib/ZmqTypes.h"

#include "WaveformViewerConfig.h"

using DevChInvert = QVector<bool>;

struct AfiViewerConfig
{
    enum class SOURCE_DATA {
        SOURCE_IDLE=0,
        SOURCE_STREAM=1,
        SOURCE_FILE=2
    };
    friend bool operator==(const AfiViewerConfig &, const AfiViewerConfig &) = default;

    ClientIndex source_program;
    QString sourceIntType;
    int sourceIntId;
    bool rawDataEveryEv = false;
    int rawDataLimit = 1;
    bool rawDataPeriodic = false;
    int rawDataPeriod = 5;
    bool useSeparateInl = false;
    QString separateInlFolder;

    SOURCE_DATA source = SOURCE_DATA::SOURCE_IDLE;
    QMap<DeviceIndex, DevChInvert > invertMap;
    FileReaderConfig file_reader_config;
    TdcTtvxsMapType tdc_ttvxs_map;

    HistMngrCfg hist_manager_config;
    WaveformViewerConfig wf_config;
    ZmqConfig zmq_config;
};
Q_DECLARE_METATYPE(AfiViewerConfig)

#endif // TDCVIEWERCONFIG_H


