#include "TaiTimeConverter.h"

#include "TaiTime.h"

namespace {
constexpr const char *k_sec = "sec";
constexpr const char *k_nSec = "ns";
constexpr const char *k_valid = "valid";
}
// --------- TaiTime

template<>
bool AbstractConfigConverter<TaiTime>::classIsObject()
{
    return true;
}

template<>
QJsonObject AbstractConfigConverter<TaiTime>::toJsonObject(const TaiTime &in)
{
    QVariantMap m;

    m[k_sec] = QVariant::fromValue(in.sec);
    m[k_nSec] = QVariant::fromValue(in.ns);
    m[k_valid] = QVariant::fromValue(in.valid);

    return fromVariantMap(m);
}

template<>
TaiTime AbstractConfigConverter<TaiTime>::fromJsonObject(const QJsonObject &in)
{
    TaiTime out;

    update_value(in, k_sec, &out.sec);
    update_value(in, k_nSec, &out.ns);
    update_value(in, k_valid, &out.valid);

    return out;
}

template<>
QJsonValue AbstractConfigConverter<TaiTime>::toJsonValue(const TaiTime &in)
{
    return toJsonObject(in);
}

template<>
TaiTime AbstractConfigConverter<TaiTime>::fromJsonValue(const QJsonValue &in)
{
    return fromJsonObject(in.toObject());
}

template<>
void AbstractConfigConverter<TaiTime>::registerSubTypes()
{
}
