/*
**    Copyright 2020 Ilja Slepnev
**
**    This program is free software: you can redistribute it and/or modify
**    it under the terms of the GNU General Public License as published by
**    the Free Software Foundation, either version 3 of the License, or
**    (at your option) any later version.
**
**    This program is distributed in the hope that it will be useful,
**    but WITHOUT ANY WARRANTY; without even the implied warranty of
**    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**    GNU General Public License for more details.
**
**    You should have received a copy of the GNU General Public License
**    along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/

#ifndef UTIL_H
#define UTIL_H

#include <QSet>

class QDebug;
class QJsonDocument;
class QObject;
class QString;
class QVariant;

QString qObjectAncestryStr(const QObject *obj);

QDebug operator<<(QDebug dbg, const QJsonDocument &doc);
void recursive_compare(const QVariant &l, const QVariant &r);

template<typename T>
int count_distinct(QList<T> v)
{
    QSet<T> distinct;
    for (auto &x : v)
        distinct.insert(x);
    return distinct.size();
}

double convertOneWireTemp(quint16 rawTemp);

#endif // UTIL_H
