#ifndef ADCDEVICEMGRFSM_H
#define ADCDEVICEMGRFSM_H

#include "DeviceMgrFsm.h"

struct AdcDeviceMgrFsmInput : public DeviceMgrFsmInput
{
    QMap<DeviceIndex, ConfigKey> deviceCalKeys;
    ConfigKey cal_key;
};

class AdcDeviceMgrFsm : public DeviceMgrFsm
{
    Q_OBJECT
public:
    AdcDeviceMgrFsm(QObject *p);

public slots:
    void setMainCalKey(const ConfigKey &key);
    void setDevCalKey(const DeviceIndex &index, const ConfigKey &key);

protected slots:
    virtual bool evaluate() override;

protected:
    virtual void printInputString(QDebug dbg) const override;
    virtual qint64 stateTimeoutMs(const FsmState &state) const override;
    inline AdcDeviceMgrFsmInput *getInput() {
        return static_cast<AdcDeviceMgrFsmInput*>(BaseFsm::getInput());
    }
    inline const AdcDeviceMgrFsmInput *getInput() const {
        return static_cast<const AdcDeviceMgrFsmInput*>(BaseFsm::getInput());
    }

    bool allDevicesCalibrated() const;
};

QDebug operator<<(QDebug dbg, const AdcDeviceMgrFsmInput &in);

#endif // ADCDEVICEMGRFSM_H
