#ifndef MSTREAMDEVICEMGRFSM_H
#define MSTREAMDEVICEMGRFSM_H

#include "DeviceMgrFsm.h"

struct MStreamDeviceMgrFsmInput : public DeviceMgrFsmInput
{
    int mstreamSeqNum = 0;
    DeviceIndexSet mstreamSet;
    QMap<DeviceIndex, int> mstreamSeqNumbers;
};

class MStreamDeviceMgrFsm : public DeviceMgrFsm
{
    Q_OBJECT
public:
    explicit MStreamDeviceMgrFsm(QObject *parent = nullptr);
    virtual bool isTransitionAllowed(const FsmState &toState) const override;

public slots:
    void setMStreamSeqNum(int seq);
    void setMStreamDevSet(const DeviceIndexSet &newSet);
    void setDevMstreamSeqNum(const DeviceIndex &index, int seq);

protected slots:
    virtual bool evaluate() override;

protected:
    virtual void printInputString(QDebug dbg) const override;
    virtual qint64 stateTimeoutMs(const FsmState &state) const override;
    inline MStreamDeviceMgrFsmInput *getInput() {
        return static_cast<MStreamDeviceMgrFsmInput*>(BaseFsm::getInput());
    }
    inline const MStreamDeviceMgrFsmInput *getInput() const {
        return static_cast<const MStreamDeviceMgrFsmInput*>(BaseFsm::getInput());
    }

    bool allMstreamReseted() const;
};

QDebug operator<<(QDebug dbg, const MStreamDeviceMgrFsmInput &in);

#endif // MSTREAMDEVICEMGRFSM_H
