#ifndef CLIENTENABLETABLEMODEL_H
#define CLIENTENABLETABLEMODEL_H


#include "ClientIndexTableModel.h"
#include "base/ClientIndexEnabled.h"

class ClientEnableTableModel : public ClientIndexTableModel
{
    Q_OBJECT
public:
    enum Columns {
        COL_ENABLE,
        COL_TYPE,
        COL_INDEX,
        COL_TOTAL
    };

    explicit ClientEnableTableModel(QObject *parent = nullptr)
        : ClientIndexTableModel(parent) {}

    int rowCount(const QModelIndex &parent = QModelIndex()) const override;
    int columnCount(const QModelIndex &parent = QModelIndex()) const override;

    Qt::ItemFlags flags(const QModelIndex & index) const override;
    QVariant data(const QModelIndex &index, int role) const override;
    QVariant headerData(int section, Qt::Orientation orientation,
                                int role = Qt::DisplayRole) const override;
    bool setData(const QModelIndex& index, const QVariant& value, int role) override;

    ClientIndex clientIndexOf(int row) const override;
    int rowOf(const ClientIndex &clientIndex) const override;

    static QVector<Columns> hiddenColumns();

signals:
    void clientListChanged(const ClientIndexEnabledMap &new_clients);

public slots:
    void setClientList(const ClientIndexEnabledMap &map);
    void setEnabled(bool en);

protected:
    ClientIndexEnabledMap clients;
    bool enabled = true;
};

#endif // CLIENTENABLETABLEMODEL_H
