/*
**    Copyright 2022 Ilia Slepnev
**
**    This program is free software: you can redistribute it and/or modify
**    it under the terms of the GNU General Public License as published by
**    the Free Software Foundation, either version 3 of the License, or
**    (at your option) any later version.
**
**    This program is distributed in the hope that it will be useful,
**    but WITHOUT ANY WARRANTY; without even the implied warranty of
**    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**    GNU General Public License for more details.
**
**    You should have received a copy of the GNU General Public License
**    along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/

#ifndef LLDPDISCOVERYDEVICELISTFILTER_H
#define LLDPDISCOVERYDEVICELISTFILTER_H

#include <QObject>

#include "base/DeviceIndexEnabled.h"
#include "LldpDiscovery.h"

class LldpDiscoveryDeviceListFilter : public QObject
{
    Q_OBJECT
public:
    explicit LldpDiscoveryDeviceListFilter(QObject *parent = nullptr)
        : QObject(parent) {}

signals:
    void lldpCacheUpdatedFiltered(const LldpInfoCache &cache);

public slots:
    void lldpCacheUpdated(const LldpInfoCache &input);
    void setDeviceList(const DeviceIndexEnabledMap &new_devices);

private:
    LldpInfoCache filterData(const LldpInfoCache &input) const;
    void refreshCache(const LldpInfoCache &input = {});

    DeviceIndexEnabledMap filter;
    LldpInfoCache dataCache;
    LldpInfoCache lastResult;
};

#endif // LLDPDISCOVERYDEVICELISTFILTER_H
