/*
**    Copyright 2022 Ilia Slepnev
**
**    This program is free software: you can redistribute it and/or modify
**    it under the terms of the GNU General Public License as published by
**    the Free Software Foundation, either version 3 of the License, or
**    (at your option) any later version.
**
**    This program is distributed in the hope that it will be useful,
**    but WITHOUT ANY WARRANTY; without even the implied warranty of
**    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**    GNU General Public License for more details.
**
**    You should have received a copy of the GNU General Public License
**    along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/

#ifndef AD5328CONFIG_H
#define AD5328CONFIG_H

#include <QMap>

class Ad5328Config
{
public:
    struct ChipConfig
    {
        friend bool operator==(const ChipConfig &, const ChipConfig &) = default;

        bool bufferedInput = true;
        bool doubleGain = false;
        QMap<int, int> dacValue;
    };

    friend bool operator==(const Ad5328Config &, const Ad5328Config &) = default;

    QMap<int, ChipConfig> chips;
};

#endif // AD5328CONFIG_H
