#ifndef ADCMPDTRIGCONFIG_H
#define ADCMPDTRIGCONFIG_H

#include <QMetaType>

struct AdcMpdTrigChConfig
{
    friend bool operator==(const AdcMpdTrigChConfig &, const AdcMpdTrigChConfig &) = default;

    constexpr static const bool DEF_CH_EN = true;
    constexpr static const bool DEF_CH_POL = true;
    bool en = DEF_CH_EN;
    bool pol = DEF_CH_POL; // false - active-high, true - active-low
    quint16 adcCh = 0;
};
Q_DECLARE_METATYPE(AdcMpdTrigChConfig)

struct AdcMpdTrigGroupConfig
{
    friend bool operator==(const AdcMpdTrigGroupConfig &, const AdcMpdTrigGroupConfig &) = default;

    QVector<AdcMpdTrigChConfig> channels;
    quint32 trigThr;
};
Q_DECLARE_METATYPE(AdcMpdTrigGroupConfig)

struct AdcMpdTrigConfig
{
    friend bool operator==(const AdcMpdTrigConfig &, const AdcMpdTrigConfig &) = default;

    QVector<AdcMpdTrigGroupConfig> groups;
    QVector<qint16> adcStaticCompensation;
};
Q_DECLARE_METATYPE(AdcMpdTrigConfig)

#endif // ADCMPDTRIGCONFIG_H
