#ifndef ADCSPIAD9249MODULE_H
#define ADCSPIAD9249MODULE_H

#include "BaseDeviceModule.h"
#include "device-modules/AdcSpiBaseModule.h"

class AdcSpiAd9249Module : public BaseDeviceModule<AdcSpiAd9249Module>, public AdcSpiBaseModule
{
public:
    explicit AdcSpiAd9249Module(const MregBusInterface &bus);

    static QList<AFI_SDB_ID> getSupportedSdbIds();
    virtual void post_init() override;

    virtual bool setupAdc() override;
    bool setCustomPatternMode(bool mode) override;
    bool setCustomPattern(quint16 data) override;

private:
    bool spi_write(quint16 addr, quint8 data, quint16 device_mask);
    bool spi_read(quint16 addr, quint16 *result, quint16 device_mask);
    bool spi_test_impl(TestResult *result) override;
};

#endif // ADCSPIAD9249MODULE_H
