#ifndef CLOCKCONTROLMODULE_H
#define CLOCKCONTROLMODULE_H

#include <optional>

#include "ClockControl/ClockStatus.h"
#include "device-modules/BaseDeviceModule.h"

struct ClockStatus;
class ClockControlConfig;

class ClockControlModule : public BaseDeviceModule<ClockControlModule>
{
public:
    explicit ClockControlModule(const MregBusInterface &bus) : BaseDeviceModule(bus) {}

    static QList<AFI_SDB_ID> getSupportedSdbIds();

    virtual void post_init() override;

    bool writeConfig(const ClockControlConfig &config);
    std::optional<ClockStatus> readStatus();
    std::optional<ClockBuildParams> getBuildParam() const { return buildParams; }

protected:
    mlink::RegOpVector getStatusRegOp() const;
    static std::optional<ClockStatus> decodeStatus(const mlink::RegOpVector &regRes, int posOffset = 0);

private:
    bool readBuildParams();
    bool isV2() const;

    std::optional<ClockBuildParams> buildParams;
};

#endif // CLOCKCONTROLMODULE_H
