#ifndef CROSSPOINTSWITCHMODULE_H
#define CROSSPOINTSWITCHMODULE_H

#include <optional>

#include "CrosspointSwitchBuildParams.h"
#include "device-modules/BaseDeviceModule.h"

struct CrosspointSwitchConfig;
namespace mlink { class RegOpVector; }

class CrosspointSwitchModule : public BaseDeviceModule<CrosspointSwitchModule>
{
public:
    explicit CrosspointSwitchModule(const MregBusInterface &bus) : BaseDeviceModule(bus) {}

    static QList<AFI_SDB_ID> getSupportedSdbIds();
    virtual void post_init() override;

    std::optional<CrosspointSwitchBuildParams> getBuildParam() const
    {
        return buildParams;
    }

    bool writeConfig(const CrosspointSwitchConfig &cfg);

private:
    std::optional<CrosspointSwitchBuildParams> buildParams;
};

#endif // CROSSPOINTSWITCHMODULE_H
