#include "FeLinkConfigConverter.h"

#include "FeLinkConfig.h"

namespace {
constexpr const char *k_chCfg = "chCfg";
constexpr const char *k_recvTrig = "recvTrig";
constexpr const char *k_reset = "reset";
constexpr const char *k_resetSoftPll = "resetSoftPll";
constexpr const char *k_remoteReset = "remoteReset";
}

// -------------- FeLinkChConfig
template<>
bool AbstractConfigConverter<FeLinkChConfig>::classIsObject()
{
    return true;
}

template<>
QJsonObject AbstractConfigConverter<FeLinkChConfig>::toJsonObject(const FeLinkChConfig &in)
{
    QVariantMap m;
    m[k_recvTrig] = QVariant::fromValue(in.recvTrig);
    m[k_reset] = QVariant::fromValue(in.reset);
    m[k_resetSoftPll] = QVariant::fromValue(in.resetSoftPll);
    m[k_remoteReset] = QVariant::fromValue(in.remoteReset);
    return fromVariantMap(m);
}

template<>
FeLinkChConfig AbstractConfigConverter<FeLinkChConfig>::fromJsonObject(const QJsonObject &in)
{
    FeLinkChConfig out;
    update_value(in, k_recvTrig, &out.recvTrig);
    update_value(in, k_reset, &out.reset);
    update_value(in, k_resetSoftPll, &out.resetSoftPll);
    update_value(in, k_remoteReset, &out.remoteReset);
    return out;
}

template<>
QJsonValue AbstractConfigConverter<FeLinkChConfig>::toJsonValue(const FeLinkChConfig &in)
{
    return toJsonObject(in);
}

template<>
FeLinkChConfig AbstractConfigConverter<FeLinkChConfig>::fromJsonValue(const QJsonValue &in)
{
    return fromJsonObject(in.toObject());
}

template<>
void AbstractConfigConverter<FeLinkChConfig>::registerSubTypes()
{}

// -------------- FeLinkConfig
template<>
bool AbstractConfigConverter<FeLinkConfig>::classIsObject()
{
    return true;
}

template<>
QJsonObject AbstractConfigConverter<FeLinkConfig>::toJsonObject(const FeLinkConfig &in)
{
    QVariantMap m;
    m[k_chCfg] = ConfigConverterUtil::toJsonValue(in.chCfg);
    return fromVariantMap(m);
}

template<>
FeLinkConfig AbstractConfigConverter<FeLinkConfig>::fromJsonObject(const QJsonObject &in)
{
    FeLinkConfig out;
    out.chCfg = ConfigConverterUtil::toVector<FeLinkChConfig>(in[k_chCfg]);
    return out;
}

template<>
QJsonValue AbstractConfigConverter<FeLinkConfig>::toJsonValue(const FeLinkConfig &in)
{
    return toJsonObject(in);
}

template<>
FeLinkConfig AbstractConfigConverter<FeLinkConfig>::fromJsonValue(const QJsonValue &in)
{
    return fromJsonObject(in.toObject());
}

template<>
void AbstractConfigConverter<FeLinkConfig>::registerSubTypes()
{
    AbstractConfigConverter<FeLinkChConfig>::registerTypes();
}
