#ifndef HITCOREMODULE_H
#define HITCOREMODULE_H

#include <optional>

#include "device-modules/BaseDeviceModule.h"

class HitCoreConfig;
class HitCoreStatus;

class HitCoreModule : public BaseDeviceModule<HitCoreModule>
{
public:
    explicit HitCoreModule(const MregBusInterface &bus);

    static QList<AFI_SDB_ID> getSupportedSdbIds();

    bool writeConfig(const HitCoreConfig &config);
    bool readStatus(HitCoreStatus *result);
    std::optional<HitCoreStatus> readStatus();

    QVector<quint64> readCmpState(int num_samples = 1);
};

#endif // HITCOREMODULE_H
