#ifndef MSCCYCLECOUNTERSMODULE_H
#define MSCCYCLECOUNTERSMODULE_H

#include "base/TaiTime.h"
#include "device-modules/BaseDeviceModule.h"

#include "MscCycleStatus.h"

class MscCycleCountersModule : public BaseDeviceModule<MscCycleCountersModule>
{
    struct gate_start_t {
        uint32_t gateCnt = 0;
        TaiTime gateStart;
    };

public:
    explicit MscCycleCountersModule(const MregBusInterface &bus) : BaseDeviceModule(bus) {}

    static QList<AFI_SDB_ID> getSupportedSdbIds();

    void post_init() final;
    bool readStatus(MscCycleStatus *result);
    std::optional<MscCycleStatus> readStatus();

private:
    mlink::RegOpVector getStatusRegOp(MscCycleStatus *result) const;

    quint16 numOfHists = 0;
    QVector<gate_start_t> prevGateStart;
    MscCycleStatus curStatus;
};

#endif // MSCCYCLECOUNTERSMODULE_H
