#ifndef MSCINPUTMODULE_H
#define MSCINPUTMODULE_H

#include <optional>

#include "MscInputConfig.h"
#include "MscInputStatus.h"
#include "device-modules/BaseDeviceModule.h"

class ModularMregDevice;

class MscInputModule : public BaseDeviceModule<MscInputModule>
{
public:
    explicit MscInputModule(const MregBusInterface &bus) : BaseDeviceModule(bus) {}

    static QList<AFI_SDB_ID> getSupportedSdbIds();

    void post_init() final;

    std::optional<MscInputBuildParams> getBuildParam() const { return buildParams; }
    bool writeConfig(const MscInputConfig &cfg);
    std::optional<MscInputStatus> readStatus();
    bool readStatus(MscInputStatus *result);
    QVector<quint64> readCmpState(int num_samples = 1);

private:
    void readBuildParam();
    int getCeInputCount() const;
    mlink::RegOpVector setConfigRegOp(const MscInputConfig &cfg) const;
    mlink::RegOpVector getStatusRegOp(MscInputStatus *result) const;

    std::optional<MscInputBuildParams> buildParams;
};

#endif // MSCINPUTMODULE_H
