#ifndef REGWRTIMETAI_H
#define REGWRTIMETAI_H

#include <cstdint>

#include "base/TaiTime.h"

typedef union __attribute__((packed)) reg_wr_time_tai {
    TaiTime toTaiTime() const
    {
        TaiTime tai;
        tai.sec = static_cast<int32_t>(bit.sec);
        tai.ns = bit.nSec;
        tai.valid = bit.flags == 0x2;
        return tai;
    }

    uint64_t all;
    struct
    {
        uint8_t flags : 2;
        uint32_t nSec : 30;
        uint32_t sec;
    } bit;
} reg_wr_time_tai;

class RegWrTaiTime : public TaiTime
{
public:
    static uint64_t toRaw(const TaiTime &tai)
    {
        reg_wr_time_tai reg;
        reg.bit.sec = tai.sec;
        reg.bit.nSec = tai.ns;
        reg.bit.flags = tai.isValid() ? 0x2 : 0;
        return reg.all;
    }

    static TaiTime fromRaw(uint64_t raw)
    {
        reg_wr_time_tai reg;
        reg.all = raw;
        return reg.toTaiTime();
    }
};

#endif // REGWRTIMETAI_H
