#include "Tlu40LvdsTofTriggerConfigConverter.h"

#include "Tlu40LvdsTofTriggerConfig.h"

namespace {
// Tlu40LvdsTofTriggerModConfig
constexpr const char *k_shaperVal = "shaperVal";
constexpr const char *k_chEn = "chEn";

// Tlu40LvdsTofTriggerConfig
constexpr const char *k_modConfig = "modConfig";
}

// -------------- Tlu40LvdsTofTriggerModConfig
template<>
bool AbstractConfigConverter<Tlu40LvdsTofTriggerModConfig>::classIsObject()
{
    return true;
}

template<>
QJsonObject AbstractConfigConverter<Tlu40LvdsTofTriggerModConfig>::toJsonObject(const Tlu40LvdsTofTriggerModConfig &in)
{
    QVariantMap m;
    m[k_chEn] = ConfigConverterUtil::toJsonValue(in.chEn);
    m[k_shaperVal] = QVariant::fromValue(in.shaperVal);
    return fromVariantMap(m);
}

template<>
Tlu40LvdsTofTriggerModConfig AbstractConfigConverter<Tlu40LvdsTofTriggerModConfig>::fromJsonObject(const QJsonObject &in)
{
    Tlu40LvdsTofTriggerModConfig out;
    out.chEn = ConfigConverterUtil::toVector<bool>(in[k_chEn]);
    update_value(in, k_shaperVal, &out.shaperVal);
    return out;
}

template<>
QJsonValue AbstractConfigConverter<Tlu40LvdsTofTriggerModConfig>::toJsonValue(const Tlu40LvdsTofTriggerModConfig &in)
{
    return toJsonObject(in);
}

template<>
Tlu40LvdsTofTriggerModConfig AbstractConfigConverter<Tlu40LvdsTofTriggerModConfig>::fromJsonValue(const QJsonValue &in)
{
    return fromJsonObject(in.toObject());
}

template<>
void AbstractConfigConverter<Tlu40LvdsTofTriggerModConfig>::registerSubTypes()
{
}

// -------------- Tlu40LvdsTofTriggerConfig
template<>
bool AbstractConfigConverter<Tlu40LvdsTofTriggerConfig>::classIsObject()
{
    return true;
}

template<>
QJsonObject AbstractConfigConverter<Tlu40LvdsTofTriggerConfig>::toJsonObject(const Tlu40LvdsTofTriggerConfig &in)
{
    QVariantMap m;
    m[k_modConfig] = ConfigConverterUtil::toJsonValue(in.modConfig);

    return fromVariantMap(m);
}

template<>
Tlu40LvdsTofTriggerConfig AbstractConfigConverter<Tlu40LvdsTofTriggerConfig>::fromJsonObject(const QJsonObject &in)
{
    Tlu40LvdsTofTriggerConfig out;
    out.modConfig = ConfigConverterUtil::toVector<Tlu40LvdsTofTriggerModConfig>(in[k_modConfig]);
    return out;
}

template<>
QJsonValue AbstractConfigConverter<Tlu40LvdsTofTriggerConfig>::toJsonValue(const Tlu40LvdsTofTriggerConfig &in)
{
    return toJsonObject(in);
}

template<>
Tlu40LvdsTofTriggerConfig AbstractConfigConverter<Tlu40LvdsTofTriggerConfig>::fromJsonValue(const QJsonValue &in)
{
    return fromJsonObject(in.toObject());
}

template<>
void AbstractConfigConverter<Tlu40LvdsTofTriggerConfig>::registerSubTypes()
{
    AbstractConfigConverter<Tlu40LvdsTofTriggerModConfig>::registerTypes();
}

// // -------------- AdcMpdTrigConfig
// template<>
// bool AbstractConfigConverter<AdcMpdTrigConfig>::classIsObject()
// {
//     return true;
// }

// template<>
// QJsonObject AbstractConfigConverter<AdcMpdTrigConfig>::toJsonObject(const AdcMpdTrigConfig &in)
// {
//     QVariantMap m;
//     m[k_groups] = ConfigConverterUtil::toJsonValue(in.groups);
//     m[k_adcStaticCompensation] = ConfigConverterUtil::toJsonValue(in.adcStaticCompensation);
//     return fromVariantMap(m);
// }

// template<>
// AdcMpdTrigConfig AbstractConfigConverter<AdcMpdTrigConfig>::fromJsonObject(const QJsonObject &in)
// {
//     AdcMpdTrigConfig out;
//     out.groups = ConfigConverterUtil::toVector<Tlu40LvdsTofTriggerConfig>(in[k_groups]);
//     out.adcStaticCompensation = ConfigConverterUtil::toVector<qint16>(in[k_adcStaticCompensation]);
//     return out;
// }

// template<>
// QJsonValue AbstractConfigConverter<AdcMpdTrigConfig>::toJsonValue(const AdcMpdTrigConfig &in)
// {
//     return toJsonObject(in);
// }

// template<>
// AdcMpdTrigConfig AbstractConfigConverter<AdcMpdTrigConfig>::fromJsonValue(const QJsonValue &in)
// {
//     return fromJsonObject(in.toObject());
// }

// template<>
// void AbstractConfigConverter<AdcMpdTrigConfig>::registerSubTypes()
// {
//     AbstractConfigConverter<Tlu40LvdsTofTriggerConfig>::registerTypes();
// }
