#include "TluTtlIoControlConfigConverter.h"

#include "TluTtlIoControlConfig.h"

#include "base/ConfigConverterUtil.h"

template<>
bool AbstractConfigConverter<TluTtlIoControlConfig>::classIsObject()
{
    return false;
}

template<>
QJsonObject AbstractConfigConverter<TluTtlIoControlConfig>::toJsonObject(const TluTtlIoControlConfig &in)
{
    Q_UNUSED(in)
    Q_UNREACHABLE();
}

template<>
TluTtlIoControlConfig AbstractConfigConverter<TluTtlIoControlConfig>::fromJsonObject(const QJsonObject &in)
{
    Q_UNUSED(in)
    Q_UNREACHABLE();
}

template<>
QJsonValue AbstractConfigConverter<TluTtlIoControlConfig>::toJsonValue(const TluTtlIoControlConfig &in)
{
    QList<quint16> list;
    for(auto v : in.ttlCfg)
        list << v.all;
    return ConfigConverterUtil::toJsonValue(list);
}

template<>
TluTtlIoControlConfig AbstractConfigConverter<TluTtlIoControlConfig>::fromJsonValue(const QJsonValue &in)
{
    const auto &list = ConfigConverterUtil::toList<quint32>(in);
    TluTtlIoControlConfig out;
    for(auto v : list) {
        reg_tlu_ttl_io_t r;
        r.all = v;
        out.ttlCfg.push_back(r);
    }
    return out;
}

template<>
void AbstractConfigConverter<TluTtlIoControlConfig>::registerSubTypes()
{
}
