#ifndef TRCERCMODULE_H
#define TRCERCMODULE_H

#include "device-modules/BaseDeviceModule.h"

#include <optional>

class TrcErcModule : public BaseDeviceModule<TrcErcModule>
{
public:
    explicit TrcErcModule(const MregBusInterface &bus) : BaseDeviceModule(bus) {}

    static QList<AFI_SDB_ID> getSupportedSdbIds();

    bool readGlobEvNum(quint64 *globEvNum);
    std::optional<quint64> readGlobEvNum();

    bool writeConfig(bool oscEn);

    bool setGlobEvNum(quint64 evNum);

private:
    mlink::RegOpVector setGlobEvNumRegOp(quint64 evNum) const;
    inline quint16 getControlReg() const;
    bool channelOscilogramEnable = false;

};
#endif // TRCERCMODULE_H
