/*
**    Copyright 2011-2022 Ilia Slepnev
**
**    This program is free software: you can redistribute it and/or modify
**    it under the terms of the GNU General Public License as published by
**    the Free Software Foundation, either version 3 of the License, or
**    (at your option) any later version.
**
**    This program is distributed in the hope that it will be useful,
**    but WITHOUT ANY WARRANTY; without even the implied warranty of
**    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**    GNU General Public License for more details.
**
**    You should have received a copy of the GNU General Public License
**    along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/

#ifndef TTBMODULECONFIG_H
#define TTBMODULECONFIG_H

#include <QMap>
#include <QMetaType>

inline constexpr const int TTB_CH_COUNT = 9;

struct TtbModuleConfig
{
    TtbModuleConfig();
    friend bool operator==(const TtbModuleConfig &, const TtbModuleConfig &) = default;
    void mergeLocalData(const TtbModuleConfig &r)
    {
        chEn = r.chEn;
    }

    QMap<int, bool> chEn;
};

Q_DECLARE_METATYPE(TtbModuleConfig)

#endif // TTBMODULECONFIG_H
