#include "TtlIoConfigConverter.h"

#include "base/ConfigConverterUtil.h"

template<>
bool AbstractConfigConverter<TtlIoConfig>::classIsObject()
{
    return false;
}

template<>
QJsonObject AbstractConfigConverter<TtlIoConfig>::toJsonObject(const TtlIoConfig &in)
{
    Q_UNUSED(in)
    Q_UNREACHABLE();
}

template<>
TtlIoConfig AbstractConfigConverter<TtlIoConfig>::fromJsonObject(const QJsonObject &in)
{
    Q_UNUSED(in)
    Q_UNREACHABLE();
}

template<>
QJsonValue AbstractConfigConverter<TtlIoConfig>::toJsonValue(const TtlIoConfig &in)
{
    QList<quint16> list;
    for(auto v : in.ttl_regs)
        list << v.all;
    return ConfigConverterUtil::toJsonValue(list);
}

template<>
TtlIoConfig AbstractConfigConverter<TtlIoConfig>::fromJsonValue(const QJsonValue &in)
{
    const auto &list = ConfigConverterUtil::toList<quint32>(in);
    TtlIoConfig out;
    for(auto v : list) {
        reg_ttl_io_t r;
        r.all = v;
        out.ttl_regs.push_back(r);
    }
    return out;
}

template<>
void AbstractConfigConverter<TtlIoConfig>::registerSubTypes()
{
}
