#ifndef ADCBUILDPARAMS_H
#define ADCBUILDPARAMS_H

#include <QMetaType>

struct AdcBuildParams
{
    friend bool operator==(const AdcBuildParams &, const AdcBuildParams &) = default;
    bool isValid() const {
        return (adcNCh > 0)
            && (adcBits >= 8 && adcBits <= 16)
            && (adcChips > 0)
            && (adcChPerChip > 0)
            && (adcMaxLat > 0)
            && (adcMaxMatchWin > 0);
    }
    int adcNCh=0;
    quint8 adcBits=0;
    quint8 adcChips=0;
    quint8 adcChPerChip=0;
    int adcMaxLat=0;
    int adcMaxMatchWin=0;
};
Q_DECLARE_METATYPE(AdcBuildParams)

#endif // ADCBUILDPARAMS_H
