#ifndef WRSTATUSMODULE_H
#define WRSTATUSMODULE_H

#include <optional>

#include "device-modules/BaseDeviceModule.h"

struct WrStatus;
namespace mlink { class RegOpVector; }

class WrStatusModule : public BaseDeviceModule<WrStatusModule>
{
public:
    explicit WrStatusModule(const MregBusInterface &bus) : BaseDeviceModule(bus) {}

    static QList<AFI_SDB_ID> getSupportedSdbIds();

    virtual void post_init() override;

    std::optional<WrStatus> readStatus();
    bool readStatus(WrStatus *result);

private:
    mlink::RegOpVector getStatusRegOp(WrStatus *result) const;
};

#endif // WRSTATUSMODULE_H
