#include "TqdcAppConfigUtil.h"
#include "lib-common/BaseDeviceAppConfig.h"
#include <optional>

int TqdcAppConfigUtil::getTqdcSimilarCfgField(const BaseDeviceAppConfig &appConfig, QMap<int, int> TqdcCoreConfig::*f)
{
    if (appConfig.knownConfigs.isEmpty())
        return appConfig.defaultSetup.tqdcCore.getSimilarField(f);

    for (auto &ds : appConfig.knownConfigs)
        if (ds.enabled)
            return ds.tqdcCore.getSimilarField(f);

    return appConfig.knownConfigs.first().tqdcCore.getSimilarField(f);
}

void TqdcAppConfigUtil::setTqdcThreshold(BaseDeviceAppConfig *appConfig, QMap<int, int> TqdcCoreConfig::*f, int thr)
{
    appConfig->defaultSetup.tqdcCore.setField(f, thr);
    for (auto &ds : appConfig->knownConfigs)
        ds.tqdcCore.setField(f, thr);
}
