#ifndef DLNPCALIBRATIONTRIGGERWIDGET_H
#define DLNPCALIBRATIONTRIGGERWIDGET_H

#include <QGroupBox>
#include <optional>

class DlnpCalibrationTriggerWidgetPrivate;
namespace Ui {
class DlnpCalibrationTriggerWidget;
}
struct DlnpCalibrationTriggerBuildParams;
struct DlnpCalibrationTriggerConfig;
class DeviceIndex;

class DlnpCalibrationTriggerWidget : public QGroupBox
{
    Q_OBJECT

public:
    explicit DlnpCalibrationTriggerWidget(QWidget *parent = nullptr);
    ~DlnpCalibrationTriggerWidget() override;

public slots:
    void setDlnpCalibrationTriggerConfig(const DlnpCalibrationTriggerConfig &c);
    void dlnpCalibrationTriggerBpUpdated(const DeviceIndex &index, const DlnpCalibrationTriggerBuildParams &bp);

signals:
    void dlnpCalibrationTriggerConfigChanged(const DlnpCalibrationTriggerConfig &cfg) const;

private slots:
    void on_checkBoxEn_toggled(bool en);
    void on_spinBoxPeriod_valueChanged(int periodUs);
    void on_spinBoxCount_valueChanged(int count);
    void on_spinBoxOffset_valueChanged(int offsetUs);


private:
    void restoreGui();

    Ui::DlnpCalibrationTriggerWidget *ui;
    Q_DECLARE_PRIVATE(DlnpCalibrationTriggerWidget)
    QScopedPointer<DlnpCalibrationTriggerWidgetPrivate> const d_ptr;
};

#endif // DLNPCALIBRATIONTRIGGERWIDGET_H
