#ifndef FELINKTREEVIEWFANCY_H
#define FELINKTREEVIEWFANCY_H

#include "FeLinkTreeView.h"

#include <QMap>
#include <QSet>

class QMenu;

class FeLinkTreeViewFancy : public FeLinkTreeView
{
    Q_OBJECT

public:
    FeLinkTreeViewFancy(QWidget *parent = nullptr);
    virtual void setModel(QAbstractItemModel *model) override;
    void setDefaultColumnState();

public slots:
    void hideColumn(int column);
    void showColumn(int column);

protected slots:
    void horizontalHeaderPopup(const QPoint &pos);
    void hideColumnAction();
    void showAllColumnsSetAction();
    void setColumnSetAction();
    void showColumnAction();
    void toggleColumnAction();
    virtual void deferredInit();

protected:
    void saveColumnState(int column, bool shown = true);
    QVariant loadColumnState(int column);
    QString columnSettingsKey(int column);

private:
    QMap<int, bool> defaultColumnState() const;
    QSet<int> getColumnSetDefault() const;

    QMenu * const headerPopupMenu;
};

#endif // FELINKTREEVIEWFANCY_H
