#include "HptdcStatusDialog.h"
#include "ui_HptdcStatusDialog.h"

#include<QDebug>

#include "HptdcStatusModel.h"

HptdcStatusDialog::HptdcStatusDialog(QWidget *parent) :
      QDialog(parent)
    , ui(new Ui::HptdcStatusDialog)
    , model(new HptdcStatusModel(this))
{
    ui->setupUi(this);
    ui->treeView->header()->setSectionResizeMode(QHeaderView::ResizeToContents);
    ui->treeView->setModel(model);
}

HptdcStatusDialog::~HptdcStatusDialog()
{
    delete ui;
}

void HptdcStatusDialog::setDeviceList(const DeviceIndexEnabledMap &new_devices)
{
    model->setDeviceList(new_devices);
}

void HptdcStatusDialog::deviceStatusUpdated(const DeviceIndex &deviceIndex,
                                            const TdcCoreStatus &status)
{
    model->setHptdcStatusMap(deviceIndex, status);
}

void HptdcStatusDialog::setCurentDeviceIndex(const DeviceIndex &deviceIndex)
{
    const auto index = model->indexOf(deviceIndex);
    ui->treeView->setCurrentIndex(index);
    ui->treeView->collapseAll();
    ui->treeView->expand(index);
}
