/*
**    Copyright 2021 Ilia Slepnev
**
**    This program is free software: you can redistribute it and/or modify
**    it under the terms of the GNU General Public License as published by
**    the Free Software Foundation, either version 3 of the License, or
**    (at your option) any later version.
**
**    This program is distributed in the hope that it will be useful,
**    but WITHOUT ANY WARRANTY; without even the implied warranty of
**    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**    GNU General Public License for more details.
**
**    You should have received a copy of the GNU General Public License
**    along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/

#include "MessageSubscriber.h"

#include <QDebug>
#include <QVariant>

#include "impl/AbstractSubscriber.h"
#ifdef ZMQKV_SUBSCRIBER
#include "impl/zmqkv/ZmqKvSubscriber.h"
#endif

MessageSubscriber::MessageSubscriber(QObject *parent) : QObject(parent)
{
    setObjectName("MessageSubscriber");

#ifdef ZMQKV_SUBSCRIBER
    impl_zmqkv = new ZmqKvSubscriber("zmqkv", this);
    connect(impl_zmqkv, &ZmqKvSubscriber::messageReceived, this, &MessageSubscriber::messageReceived);
#endif
}

void MessageSubscriber::subscribe(const QString &topic)
{
#ifdef ZMQKV_SUBSCRIBER
    if (impl_zmqkv)
        impl_zmqkv->subscribe(topic);
#endif
}
