#ifndef MLINK_REGIOMLINK_H
#define MLINK_REGIOMLINK_H

/*
 * Register-based I/O
 */

#include <vector>

#include <QHostAddress>
#include <QPointer>

#include <regio/regiobase.h>

class QUdpSocket;
class QByteArray;

namespace mlink {

const int MlinkHostAddress = 1;

class RegIOMLink: public RegIOBase
{
    Q_OBJECT

public:
    explicit RegIOMLink(QObject *parent = nullptr);
    ~RegIOMLink() override;
    void reset() override;
    void rawSend(const RegIoPacket &data) override; //< \deprecated
    unsigned long getMaxDataSize() const override;

protected:
    double getDeviceThroughput() const override;
    //  virtual PacketList getRxPackets(double timeout); //<! get packets from hardware
    void processPacket(const QByteArray &buf);
    bool updateRxBuf(double timeoutMs) override;

    std::vector<int> rawRxBuf;
    QPointer<QUdpSocket> socket;

private Q_SLOTS:
    void readSocketData();
};

} // namespace mlink

#endif /* MLINK_REGIOMLINK_H */
