/*
**    Copyright 2020 Ilia Slepnev
**
**    This program is free software: you can redistribute it and/or modify
**    it under the terms of the GNU General Public License as published by
**    the Free Software Foundation, either version 3 of the License, or
**    (at your option) any later version.
**
**    This program is distributed in the hope that it will be useful,
**    but WITHOUT ANY WARRANTY; without even the implied warranty of
**    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**    GNU General Public License for more details.
**
**    You should have received a copy of the GNU General Public License
**    along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/

#ifndef PNPSERVERWITHSTATS_H
#define PNPSERVERWITHSTATS_H

#include <QObject>
#include "PNPServer.h"
#include "PnpServerStats.h"

class PnpServerWithStats : public PNPServer
{
    Q_OBJECT
public:
    explicit PnpServerWithStats(QObject *parent = nullptr);

signals:
    void statsUpdated(const PnpMessageStats &) const;

protected slots:
    virtual bool decode(const QByteArray &data, const QHostAddress &host);

private slots:
    void sendStats();

private:
    PnpMessageStats pnpMessageStats;
};

#endif // PNPSERVERWITHSTATS_H
