/*
**    Copyright 2020 Ilia Slepnev
**
**    This program is free software: you can redistribute it and/or modify
**    it under the terms of the GNU General Public License as published by
**    the Free Software Foundation, either version 3 of the License, or
**    (at your option) any later version.
**
**    This program is distributed in the hope that it will be useful,
**    but WITHOUT ANY WARRANTY; without even the implied warranty of
**    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**    GNU General Public License for more details.
**
**    You should have received a copy of the GNU General Public License
**    along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/

#ifndef REMOTECONTROLSERVERSTATUS_H
#define REMOTECONTROLSERVERSTATUS_H

#include <QHostAddress>
#include <QMetaType>

struct RemoteControlServerStatus
{
    RemoteControlServerStatus(quint16 _preferedTcpPort = 0) :
        preferedTcpPort(_preferedTcpPort)
    {}

    bool operator ==(const RemoteControlServerStatus &st) const
    {
        return tcpPort == st.tcpPort &&
               listening == st.listening &&
               portInUse == st.portInUse &&
               peerHost == st.peerHost &&
               peerPort == st.peerPort;
    }

    bool operator !=(const RemoteControlServerStatus &st) const
    {
        return !(this->operator ==(st));
    }

    quint16 preferedTcpPort = 0;
    quint16 tcpPort = 0;
    bool listening = false;
    bool portInUse = false;
    QHostAddress peerHost;
    quint16 peerPort = 0;
    int trashedSize = 0;
};

Q_DECLARE_METATYPE(RemoteControlServerStatus)

#endif // REMOTECONTROLSERVERSTATUS_H
